/*
 * lhcut ver 0.00
 *	copyright (c) 1998 Osamu KURATI
 */

#include <stdio.h>
#include <string.h>

#ifdef DOS
#define OPENMODE "rb"
#else
#define OPENMODE "r"
#endif

void usage(p_s)
char *p_s;
{
   fprintf(stderr,"usage: %s [file]\n",p_s);
   exit(1);
}

void FileNotFoundError(p_sProg,p_sFname)
char *p_sProg,*p_sFname;
{
   fprintf(stderr,"%s : file not found ... %s\n",p_sProg,p_sFname);
   exit(1);
}

int main(argc,argv)
int argc;
char *argv[];
{
   FILE *fp;
   char c_;
   char s1_[20];
   int i_, bFound_;

   if (argc <= 1) {
      /*      usage(argv[0]);*/
      fp = stdin;
   } else if ((fp = fopen(argv[1],OPENMODE)) == NULL) {
      FileNotFoundError(argv[0],argv[1]);
   }

   /***** -lh?- Ĥޤõ*****/

   for(i_=0; i_<6; i_++){
      s1_[i_] = '\0';
   }

   bFound_ = 0;
   c_ = fgetc(fp);
   while(!feof(fp) && bFound_ == 0){
      s1_[4] = c_;

      if (!strncmp(s1_,"-lh",3) && c_ == '-') {
	 bFound_ = 1;
      } else {
	 for(i_=0; i_<4; i_++){
	    s1_[i_] = s1_[i_+1];
	 }
	 c_ = fgetc(fp);
      }
   }

   if (bFound_ == 0) {
      (void) fprintf(stderr,"This file is not LZH archive.\n");
      exit(1);
   }

   (void) fseek(fp,-7,1);

   c_ = fgetc(fp);
   while(!feof(fp)){
      (void) fputc(c_,stdout);
      c_ = fgetc(fp);
   }

   fclose(fp);

   return(0);
}
